# CODE FOR SUBMISSION: Learning Disentangled Textual Representations via Statistical Measures of Similarity

To reproduce the experiments, please follow the procedure.

1. Download the datasets 
2. Train a model 
3. Train the adversary 

## Get the Dataset with the following links:

To reproduce our work, please consider looking at the following github that describe the used datasets. Please note that these dataset are not newly introduced. Check the main paper and supplementary for additionnal detail.

### PAN or Demographic 
https://github.com/yanaiela/demog-text-removal/tree/master/src/data

###  BLOGS
https://github.com/piesauce/privacy_hidden_representations

### Trust pilot
https://www.aclweb.org/anthology/P18-2005.pdf

### Bias in Bios
https://github.com/shauli-ravfogel/nullspace_projection
https://github.com/HanXudong/ReImplementation_Robust_and_Privacy_preserving_Text_Representations

### Celebrity profilling
https://pan.webis.de/downloads/publications/papers/wiegmann_2020.pdf <br>
https://zenodo.org/record/4461887#.YMisgTYzZhE <br>
https://pan.webis.de/clef20/pan20-web/celebrity-profiling.html <br>


### Reproducing the preprocessing

You need python2 to process tweet and pan16 rest can be processed with python3


## Train the model

Run ``train.py`` to train a model using a specific disentanglement loss (see ``mi_estimator.py`` for baselines and ``multivariate_loss.py`` for the one propose in the paper.  <br>
Example of bash can be found in ``train.sh`` 



## Evaluate the model

Run ``test_fair_classif.py`` to evaluate the trained model.
Example of bash can be found in ``eval.sh`` 

# Computing Architecture pretrained models (e.g. BERT)
For all these models, we rely each on NVIDIA-V100 with 32GB of RAM. Each model takes arround 3 hours to train. 
Evaluation requires to train and adversary which involves the training below 1 hour of GPU time. 

# Computing Architecture RNN
For all these models, we rely each on NVIDIA-V100 with 32GB of RAM. Each model takes arround 5 hours to train. 
Evaluation requires to train and adversary which involves the training below 1 hour of GPU time. 

# Code Release.
Uppon acceptance the code will be open sourced.